'''
Created on Apr 1, 2013

@author: vica
'''
import xlrd
import math
import re

class ExcelEnergyReader(object):
    
    def __init__(self, excel_file_name):
        self.excel_file_name = excel_file_name
        self.book = xlrd.open_workbook(excel_file_name)
        
        
    def GetEnergyValue(self, type_mem, size, operation):
        sheet = self.book.sheet_by_name(type_mem)
        row = int(math.log(size, 2) - 2)
        column = 1 if (operation == 'r') else 2 
#        print row, column
#        print sheet.cell_value(row, column)
        return float(sheet.cell_value(row, column))
        


def GetNumberOfWords(class_name):
    p = re.compile("(\d+)Word")
    m = p.search(class_name)
    return int(m.group(1))


if __name__ == '__main__':
    eer = ExcelEnergyReader("ev.xlsx")
    eer.GetEnergyValue("Data", 32, "r")
