'''
Created on Nov 15, 2012

@author: vcarlos
'''
import kct
import os


def RunSim(sim, all_file):
    
    import inspect
    import scenarios
    reload(scenarios)
    print "current", scenarios.current_sim
    dir_name = os.path.dirname(inspect.getfile(scenarios.current_sim))
#    import pdb;pdb.set_trace()
#    scenarios.current_sim = sim
    output_file_name = str(scenarios.current_sim.__name__) + ".csv"
    output_file_name = os.path.join(dir_name, output_file_name)
    print " output_file_name", output_file_name
    output_file = open(output_file_name, "w")
    
    number_of_trues = len([v for v in scenarios.current_sim.run.values() if v == True])

    number_of_cases = 0
    
    all_file.write(scenarios.current_sim.__name__ + "\n")
    output_file.write("Size; Misses; Hits; Cache Energy; Flash Energy; Total\n")
    all_file.write("Size; Misses; Hits; Cache Energy; Flash Energy; Total\n")
    
    for name, obj in inspect.getmembers(scenarios):
        if inspect.isclass(obj):
            if name.startswith("Factory"):
                if obj.build:
                    number_of_cases += 1
                    print "----------------------", name, "-------------------------"
#                    print name
                    sim = obj.Build()
                    sim.Run()
                    print sim
                    output_file.write(str(sim))
                    all_file.write(str(sim))
    #                print

    output_file.close()
    
    if number_of_cases != number_of_trues:
        print "ATENCAO, TEM ", number_of_trues - number_of_cases, " CASO[S] FALTANDO"
    


apps = kct.GetAvailableApps()
for app in apps:
    all_file = open(app + ".csv", "w")
    caches = kct.GetAvailableCacheArchitectures(app)
    for cache in caches:
        print "Simulating:  ", app, cache
        for sim in kct.GetAvailableSims(app, cache):
            kct.main_current_sim = sim
            if kct.main_current_sim.simulate == 20:
                RunSim(sim, all_file)    
                all_file.write("\n")
                print

    all_file.close()

#===============================================================================
# main
#===============================================================================
if __name__ == '__main__':
    pass
