#from param.ble import dm_cache_verilog_memory, dm_cache_rf_memory,\
#    dm_cache_sram_memory
    
import pkgutil
import importlib



def GetAvailableSims(application_name, cache_architecture):
    print application_name + "." + cache_architecture
    pkg_path = 'C:\\Users\\vica\\eclipse_workspaces\\HL_sim\\simulation\\param\\' + application_name  + "\\" + cache_architecture
    pkg_name = 'param.' + application_name + "." + cache_architecture
    
    modules = []
    for importer, modname, ispkg in pkgutil.walk_packages(path=[pkg_path],
                                                      prefix=pkg_name +'.',
                                                      onerror=lambda x: None):
        modules.append(importlib.import_module(modname))
    return modules    


def GetAvailableApps():
    pkg_path = 'C:\\Users\\vica\\eclipse_workspaces\\HL_sim\\simulation\\param'
    pkg_name = 'param'
    
    apps = []
    for importer, modname, ispkg in pkgutil.walk_packages(path=[pkg_path],
                                                      prefix=pkg_name +'.'):
        
        if ispkg and modname.count(".") == 1:
            modname = modname.split(".")[-1]
            apps.append(modname)
    return apps    
    


def GetAvailableCacheArchitectures(application_name):
    pkg_path = 'C:\\Users\\vica\\eclipse_workspaces\\HL_sim\\simulation\\param' + "\\" + application_name
    pkg_name = 'param.' + application_name
    
    cache_archs = []
    for importer, modname, ispkg in pkgutil.walk_packages(path=[pkg_path],
                                                      prefix=pkg_name +'.'):
        if ispkg and modname.count(".") == 2 and cache_archs.count(modname) == 0:
            modname = modname.split(".")[-1]
            cache_archs.append(modname)
    return cache_archs    
    

main_current_sim = None        
#available_sims = [dm_cache_rf_memory, dm_cache_verilog_memory, dm_cache_sram_memory]    


if __name__ == '__main__':
    pass