#===============================================================================
# General Simulation Parameters
#===============================================================================
MAIN_MEMORY_SIZE = 262144 #bytes
FLASH_ENERGY_PER_READ = 0.1593
SPM_ENERGY_PER_READ = 0.0218


#===============================================================================
# Specific Simulation Parameters
#===============================================================================
class DMCache_32Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 176 #bytes
    mapping = "000010000000111100"
    trace_file = "trace.log"
    

class DMCache_64Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 344 #bytes
    mapping = "000000010010111100"
    trace_file = "trace.log"
    

class DMCache_128Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 672 #bytes
    mapping = "000000100011111100"
    trace_file = "trace.log"
    
    
class DMCache_256Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 1312 #bytes
    mapping = "000000100111111100"
    trace_file = "trace.log"
    
    
class DMCache_512Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 2560 #bytes
    mapping = "000100110011111100"
    trace_file = "trace.log"
    
    
class DMCache_1024Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 4998 #bytes
    mapping = "001000011111111100"
    trace_file = "trace.log"
    

class DMCache_2048Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 9728 #bytes
    mapping = "001001011111111100"
    trace_file = "trace.log"
    
    
class DMCache_4096Words:
    energy_per_read = 0.3
    energy_per_write = 0.3
    cache_size = 9728 #bytes
    mapping = "000101111111111100"
    trace_file = "trace.log"