'''
Created on Nov 3, 2012

@author: vcarlos
'''

class Simulation(object):
    '''
    Runs the simulation of the system
    '''


    def __init__(self, memory_system, trace_file):
        '''
        Constructor
        '''
        self.memory_system = memory_system
        self.trace_file_name = trace_file
        self.program_trace = self._ReadProgramTrace()
        

    def _ReadProgramTrace(self, ):
        f = open(self.trace_file_name, "r")
        program_trace = []
        line  = f.readline()
        while line != "":
            l = int(line, 16)
            program_trace.append(l)
            line = f.readline()
    
        f.close()
    
        return program_trace        
        
        
    def Run(self):
        
        for each_address in self.program_trace:
            self.memory_system.Read(each_address)
            
            
    def __str__(self, *args, **kwargs):
#        result = "------------------------- Simulation Results -------------------------"
#        result += "\nProgram size: " + str(len(self.program_trace))
        result = str(self.memory_system)
#        result += "\n"
        return result
        